Index: WebCore/bindings/gdom/PrivateIntGdomEventTargetNode.h
===================================================================
--- WebCore/bindings/gdom/PrivateIntGdomEventTargetNode.h	(revision 0)
+++ WebCore/bindings/gdom/PrivateIntGdomEventTargetNode.h	(revision 0)
@@ -0,0 +1,24 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+
+#ifndef __GDOMEventTargetNode_H___INT_
+#define __GDOMEventTargetNode_H___INT_
+#include "glib-object.h"
+#include "PrivateIntGdomNode.h"
+G_BEGIN_DECLS
+
+class GDOMEventTargetNode : public GDOMNode {
+
+public:
+    GDOMEventTargetNode(PassRefPtr<WebCore::Node> impl) : GDOMNode(impl) {}
+    int get_gobj_type() { return GDOM_TYPE_EVENT_TARGET_NODE; }
+};
+
+
+G_END_DECLS
+#endif
+
Index: WebCore/bindings/gdom/GDOMBinding.cpp
===================================================================
--- WebCore/bindings/gdom/GDOMBinding.cpp	(revision 0)
+++ WebCore/bindings/gdom/GDOMBinding.cpp	(revision 0)
@@ -0,0 +1,801 @@
+/*
+ *  Copyright (C) 1999-2001 Harri Porten (porten@kde.org)
+ *  Copyright (C) 2004, 2005, 2006, 2007, 2008 Apple Inc. All rights reserved.
+ *  Copyright (C) 2007 Samuel Weinig <sam@webkit.org>
+ *  Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ *
+ *  This library is free software; you can redistribute it and/or
+ *  modify it under the terms of the GNU Lesser General Public
+ *  License as published by the Free Software Foundation; either
+ *  version 2 of the License, or (at your option) any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Lesser General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public
+ *  License along with this library; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+// gcc 3.x can't handle including the HashMap pointer specialization in this file
+#if defined __GNUC__ && !defined __GLIBCXX__ // less than gcc 3.4
+#define HASH_MAP_PTR_SPEC_WORKAROUND 1
+#endif
+
+#include "config.h"
+#include "glib-object.h"
+#include "CString.h"
+#include "GdomDOMObject.h"
+#include "PrivateGdomDOMObject.h"
+#include "GDOMBinding.h"
+#include "GDOMHTMLElementWrapperFactory.h"
+
+#include "CSSStyleSheet.h"
+#include "GdomCSSStyleSheet.h"
+#include "PrivateIntGdomCSSStyleSheet.h"
+
+#include "Document.h"
+#include "EventException.h"
+#include "ExceptionCode.h"
+#include "Frame.h"
+#include "HTMLImageElement.h"
+#include "HTMLNames.h"
+#include "GdomNode.h"
+
+#include "config.h"
+#include "PrivateIntGdomNode.h"
+
+#include "Attr.h"
+#include "CDATASection.h"
+#include "CSSValue.h"
+#include "Comment.h"
+#include "Document.h"
+#include "DocumentFragment.h"
+#include "DocumentType.h"
+#include "Entity.h"
+#include "EntityReference.h"
+#include "HTMLElement.h"
+#include "GdomEventTargetNode.h"
+#include "GdomAttr.h"
+#include "PrivateIntGdomAttr.h"
+#include "GdomCharacterData.h"
+#include "GdomText.h"
+#include "GdomCDATASection.h"
+#include "GdomComment.h"
+#include "GdomDocument.h"
+#include "GdomDocumentFragment.h"
+#include "GdomDocumentType.h"
+#include "GdomEntity.h"
+#include "GdomElement.h"
+#include "GdomCSSValueList.h"
+#include "GdomCSSPrimitiveValue.h"
+#include "GdomEntityReference.h"
+#include "GdomNotation.h"
+#include "GdomHTMLDocument.h"
+#include "GdomProcessingInstruction.h"
+#include "Node.h"
+#include "Notation.h"
+#include "ProcessingInstruction.h"
+#include "Text.h"
+#include <wtf/PassRefPtr.h>
+#include <wtf/RefPtr.h>
+
+#include "GdomCSSRule.h"
+#include "CSSCharsetRule.h"
+#include "CSSFontFaceRule.h"
+#include "CSSImportRule.h"
+#include "CSSMediaRule.h"
+#include "CSSPageRule.h"
+#include "CSSStyleRule.h"
+#include "CSSVariablesRule.h"
+#include "GdomCSSCharsetRule.h"
+#include "GdomCSSFontFaceRule.h"
+#include "GdomCSSImportRule.h"
+#include "GdomCSSMediaRule.h"
+#include "GdomCSSPageRule.h"
+#include "GdomCSSStyleRule.h"
+#include "GdomCSSVariablesRule.h"
+
+#include "config.h"
+#include "PrivateIntGdomEvent.h"
+
+#include "Clipboard.h"
+#include "Event.h"
+#include "GdomClipboard.h"
+#include "GdomKeyboardEvent.h"
+#include "GdomMessageEvent.h"
+#include "GdomMouseEvent.h"
+#include "GdomMutationEvent.h"
+#include "GdomOverflowEvent.h"
+#include "GdomProgressEvent.h"
+#include "GdomTextEvent.h"
+#include "GdomUIEvent.h"
+#include "GdomWebKitAnimationEvent.h"
+#include "GdomWebKitTransitionEvent.h"
+#include "GdomWheelEvent.h"
+#include "GdomXMLHttpRequestProgressEvent.h"
+#include "KeyboardEvent.h"
+#include "MessageEvent.h"
+#include "MouseEvent.h"
+#include "MutationEvent.h"
+#include "OverflowEvent.h"
+#include "ProgressEvent.h"
+#include "TextEvent.h"
+#include "UIEvent.h"
+#include "WebKitAnimationEvent.h"
+#include "WebKitTransitionEvent.h"
+#include "WheelEvent.h"
+#include "XMLHttpRequestProgressEvent.h"
+
+#include "GdomHTMLCollection.h"
+
+#include "AtomicString.h"
+#include "HTMLCollection.h"
+#include "HTMLOptionsCollection.h"
+// TODO #include "PrivateIntGdomHTMLAllCollection.h"
+// TODO #include "GdomHTMLAllCollection.h"
+#include "GdomHTMLOptionsCollection.h"
+// err... #include "PrivateIntGdomNamedNodesCollection.h"
+// err... #include "GdomNamedNodesCollection.h"
+
+#if ENABLE(DOM_STORAGE)
+#include "GdomStorageEvent.h"
+#include "StorageEvent.h"
+#endif
+
+#if ENABLE(SVG)
+#if 0 /* TODO */
+#include "PrivateIntGdomSVGZoomEvent.h"
+#include "GdomSVGZoomEvent.h"
+#include "SVGZoomEvent.h"
+#endif
+#endif
+
+#if ENABLE(SVG)
+#if 0 /* XXX TODO */
+#include "PrivateIntGdomSVGElementWrapperFactory.h"
+#include "GdomSVGElementWrapperFactory.h"
+#include "SVGElement.h"
+#endif
+#endif
+
+#if 0
+#if ENABLE(SVG)
+#include "GdomSVGException.h"
+#include "SVGException.h"
+#endif
+#endif
+
+#include "PrivateIntGdomClipboard.h"
+#include "PrivateIntGdomCSSRule.h"
+#include "PrivateIntGdomCDATASection.h"
+#include "PrivateIntGdomComment.h"
+#include "PrivateIntGdomDocument.h"
+#include "PrivateIntGdomDocumentFragment.h"
+#include "PrivateIntGdomDocumentType.h"
+#include "PrivateIntGdomEntity.h"
+#include "PrivateIntGdomElement.h"
+#include "PrivateIntGdomCSSValueList.h"
+#include "PrivateIntGdomCSSPrimitiveValue.h"
+#include "PrivateIntGdomEntityReference.h"
+#include "PrivateIntGdomNotation.h"
+#include "PrivateIntGdomHTMLDocument.h"
+#include "PrivateIntGdomProcessingInstruction.h"
+#include "PrivateIntGdomText.h"
+#include "PrivateIntGdomCSSCharsetRule.h"
+#include "PrivateIntGdomCSSFontFaceRule.h"
+#include "PrivateIntGdomCSSImportRule.h"
+#include "PrivateIntGdomCSSMediaRule.h"
+#include "PrivateIntGdomCSSPageRule.h"
+#include "PrivateIntGdomCSSStyleRule.h"
+#include "PrivateIntGdomCSSVariablesRule.h"
+#include "PrivateIntGdomKeyboardEvent.h"
+#include "PrivateIntGdomMessageEvent.h"
+#include "PrivateIntGdomMouseEvent.h"
+#include "PrivateIntGdomMutationEvent.h"
+#include "PrivateIntGdomOverflowEvent.h"
+#include "PrivateIntGdomProgressEvent.h"
+#include "PrivateIntGdomTextEvent.h"
+#include "PrivateIntGdomUIEvent.h"
+#include "PrivateIntGdomWebKitAnimationEvent.h"
+#include "PrivateIntGdomWebKitTransitionEvent.h"
+#include "PrivateIntGdomWheelEvent.h"
+#include "PrivateIntGdomXMLHttpRequestProgressEvent.h"
+#include "PrivateIntGdomStorageEvent.h"
+#include "PrivateIntGdomHTMLOptionsCollection.h"
+#include "PrivateIntGdomHTMLCollection.h"
+
+namespace WebCore {
+
+using namespace HTMLNames;
+
+typedef HashMap<void*, gpointer> DOMObjectMap;
+typedef HashMap<void*, gpointer> GdomWrapperCache; /* ARG! UNFAIR! JSWrapperCache is in Document!! */
+
+// For debugging, keep a set of wrappers currently registered, and check that
+// all are unregistered before they are destroyed. This has helped us fix at
+// least one bug.
+
+#if 0
+static void addWrapper(GDOMObject* wrapper);
+static void removeWrapper(GDOMObject* wrapper);
+static void removeWrappers(const GdomWrapperCache& wrappers);
+
+#ifdef NDEBUG
+
+static inline void addWrapper(GDOMObject*)
+{
+}
+
+static inline void removeWrapper(GDOMObject*)
+{
+}
+
+static inline void removeWrappers(const GdomWrapperCache&)
+{
+}
+
+#else
+
+static HashSet<GDOMObject*>& wrapperSet()
+{
+    static HashSet<GDOMObject*> staticWrapperSet;
+    return staticWrapperSet;
+}
+
+static void addWrapper(GDOMObject* wrapper)
+{
+    ASSERT(!wrapperSet().contains(wrapper));
+    wrapperSet().add(wrapper);
+}
+
+static void removeWrapper(GDOMObject* wrapper)
+{
+    if (!wrapper)
+        return;
+    ASSERT(wrapperSet().contains(wrapper));
+    wrapperSet().remove(wrapper);
+}
+
+static void removeWrappers(const GdomWrapperCache& wrappers)
+{
+    for (GdomWrapperCache::const_iterator it = wrappers.begin(); it != wrappers.end(); ++it)
+        removeWrapper(it->second);
+}
+
+GDOMObject::~GDOMObject()
+{
+    ASSERT(!wrapperSet().contains(this));
+}
+
+#endif
+#endif /* commented out for now */
+
+static GdomWrapperCache& wrapperCache()
+{ 
+    // UNFAIR! i want one of these per Document, too!
+    // Don't use malloc here. Calling malloc from a mark function can deadlock.
+    static GdomWrapperCache staticGdomWrapperCache;
+    return staticGdomWrapperCache;
+}
+
+static DOMObjectMap& domObjects()
+{ 
+    // Don't use malloc here. Calling malloc from a mark function can deadlock.
+    static DOMObjectMap staticDOMObjects;
+    return staticDOMObjects;
+}
+
+gpointer GDOMScriptInterpreter::getDOMObject(void* objectHandle) 
+{
+    gpointer ret = domObjects().get(objectHandle);
+    printf("getDOMObject: %p %p\n", objectHandle, ret);
+    return ret;
+}
+
+static gpointer create_gdom_object(GDOMObject *dob)
+{
+    gpointer res = g_object_new(dob->get_gobj_type(), NULL);
+    gdom_dom_object_set_private(GDOM_DOM_OBJECT(res), dob);
+    return res;
+}
+
+gpointer GDOMScriptInterpreter::putDOMObject(void* objectHandle, GDOMObject* wrapper) 
+{
+    // addWrapper(wrapper);
+    gpointer obj = create_gdom_object(wrapper);
+    printf("putDOMObject: %p %p %p\n", objectHandle, wrapper, obj);
+    domObjects().set(objectHandle, obj);
+    return obj;
+}
+
+void GDOMScriptInterpreter::forgetDOMObject(void* objectHandle)
+{
+    domObjects().take(objectHandle);
+    //removeWrapper(domObjects().take(objectHandle));
+}
+
+gpointer GDOMScriptInterpreter::getDOMNodeForDocument(Document* document, Node* node)
+{
+    if (!document)
+        return static_cast<gpointer >(domObjects().get(node));
+    return /* XXX grrr document-> */wrapperCache().get(node);
+}
+
+void GDOMScriptInterpreter::forgetDOMNodeForDocument(Document* document, Node* node)
+{
+    if (!document) {
+        forgetDOMObject(node);
+        return;
+    }
+    //removeWrapper(/* XXX grr document->*/wrapperCache().take(node));
+}
+
+gpointer GDOMScriptInterpreter::putDOMNodeForDocument(Document* document, Node* node, GDOMNode *wrapper)
+{
+    //addWrapper(wrapper);
+    if (!document) {
+        node->ref();
+        return GDOMScriptInterpreter::putDOMObject(node, wrapper) ;
+    }
+    gpointer obj = create_gdom_object(wrapper);
+    /* XXX grrr document->*/wrapperCache().set(node, obj);
+    return obj;
+}
+
+void GDOMScriptInterpreter::forgetAllDOMNodesForDocument(Document* document)
+{
+    ASSERT(document);
+    //removeWrappers(document->wrapperCache());
+}
+
+#if 0
+void GDOMScriptInterpreter::markDOMNodesForDocument(Document* doc)
+{
+#if 0 /*XXX TODO*/
+    // If a node's Gdom wrapper holds custom properties, those properties must
+    // persist every time the node is fetched from the DOM. So, we keep Gdom
+    // wrappers like that from being garbage collected.
+
+    GdomWrapperCache& nodeDict = /*doc->*/wrapperCache();
+    GdomWrapperCache::iterator nodeEnd = nodeDict.end();
+    for (GdomWrapperCache::iterator nodeIt = nodeDict.begin(); nodeIt != nodeEnd; ++nodeIt) {
+        gpointer gNode = nodeIt->second;
+        Node* node = gNode->impl();
+
+        if (gNode->marked())
+            continue;
+
+        // No need to preserve a wrapper that has no custom properties or is no
+        // longer fetchable through the DOM.
+        if (!gNode->hasCustomProperties() || !node->inDocument())
+            //... unless the wrapper wraps a loading image, since the "new Image"
+            // syntax allows an orphan image wrapper to be the last reference
+            // to a loading image, whose load event might have important side-effects.
+            if (!node->hasTagName(imgTag) || static_cast<HTMLImageElement*>(node)->haveFiredLoadEvent())
+                continue;
+
+        gNode->mark();
+    }
+#endif
+}
+
+/* XXX - requires looking up object - call to G_OBJECT() macro in arg
+ * "wrapper" to putDOMNodeForDocument?*/
+gpointer GDOMScriptInterpreter::updateDOMNodeDocument(Node* node, Document* oldDoc, Document* newDoc)
+{
+    ASSERT(oldDoc != newDoc);
+    styleSheet->ref();
+    gpointer wrapper = getDOMNodeForDocument(oldDoc, node);
+    if (wrapper) {
+        //removeWrapper(wrapper);
+        gpointer obj = putDOMNodeForDocument(newDoc, node, wrapper);
+        forgetDOMNodeForDocument(oldDoc, node);
+        //addWrapper(wrapper);
+        return obj;
+    }
+    return NULL; /* err... */
+}
+#endif
+
+gpointer toGDOM(Document* doc)
+{
+    if (!doc)
+        return NULL; /* XXX hmmm... */
+
+    gpointer gobj = GDOMScriptInterpreter::getDOMObject(doc);
+    if (gobj)
+        return gobj;
+
+    GDOMObject *ret;
+
+    if (doc->isHTMLDocument())
+        ret = new GDOMHTMLDocument(static_cast<HTMLDocument*>(doc));
+#if ENABLE(SVG)
+    else if (doc->isSVGDocument())
+    {
+        return NULL; /* XXX TODO */
+#if 0
+        ret = new GDOMSVGDocument(static_cast<SVGDocument*>(doc));
+#endif
+    }
+#endif
+    else
+        ret = new GDOMDocument(doc);
+
+    doc->ref();
+    return GDOMScriptInterpreter::putDOMObject(doc, ret);
+}
+
+static gpointer createWrapper(Node* node);
+
+gpointer toGDOMNewlyCreated(Node* node)
+{
+    if (!node)
+        return NULL; /* hmmm.... */
+    
+    return createWrapper(node);
+}
+    
+gpointer toGDOM(Node* node)
+{
+    if (!node)
+        return NULL; /* hmmm.... */
+
+    Document* doc = node->document();
+    gpointer ret = GDOMScriptInterpreter::getDOMNodeForDocument(doc, node);
+    if (ret)
+        return ret;
+
+    return createWrapper(node);
+}
+
+gpointer toGDOM(CSSValue* value)
+{
+    if (!value)
+        return NULL; /* hmmm... */
+
+    gpointer gobj = GDOMScriptInterpreter::getDOMObject(value);
+
+    if (gobj)
+        return gobj;
+
+    GDOMObject *ret;
+
+    if (value->isValueList())
+        ret = new GDOMCSSValueList(static_cast<CSSValueList*>(value));
+#if ENABLE(SVG)
+    else if (value->isSVGPaint())
+    {
+        return NULL; /* TODO */
+        //ret = new GDOMSVGPaint(static_cast<SVGPaint*>(value));
+    }
+    else if (value->isSVGColor())
+    {
+        return NULL; /* TODO */
+        //ret = new GDOMSVGColor(static_cast<SVGColor*>(value));
+    }
+#endif
+    else if (value->isPrimitiveValue())
+        ret = new GDOMCSSPrimitiveValue(static_cast<CSSPrimitiveValue*>(value));
+    else
+        ret = new GDOMCSSValue(value);
+
+    value->ref();
+    return GDOMScriptInterpreter::putDOMObject(value, ret);
+}
+
+static ALWAYS_INLINE gpointer createWrapper(Node* node)
+{
+    ASSERT(node);
+    ASSERT(!ScriptInterpreter::getDOMNodeForDocument(node->document(), node));
+    
+    Document* doc = node->document();
+    GDOMNode *ret = NULL;
+    
+    printf("createWrapper nodeType %d\n", node->nodeType());
+
+    switch (node->nodeType()) {
+        case Node::ELEMENT_NODE:
+            if (node->isHTMLElement())
+                ret = createGDOMHTMLWrapper(static_cast<HTMLElement*>(node));
+#if ENABLE(SVG)
+            else if (node->isSVGElement())
+                return NULL;
+#if 0 /* XXX TODO */
+                ret = createGDOMSVGWrapper(static_cast<SVGElement*>(node));
+#endif
+#endif
+            else
+                ret = new GDOMElement(static_cast<Element*>(node));
+            break;
+        case Node::ATTRIBUTE_NODE:
+            ret = new GDOMAttr(static_cast<Attr*>(node));
+            break;
+        case Node::TEXT_NODE:
+            ret = new GDOMText(static_cast<Text*>(node));
+            break;
+        case Node::CDATA_SECTION_NODE:
+            ret = new GDOMCDATASection(static_cast<CDATASection*>(node));
+            break;
+        case Node::ENTITY_NODE:
+            ret = new GDOMEntity(static_cast<Entity*>(node));
+            break;
+        case Node::PROCESSING_INSTRUCTION_NODE:
+            ret = new GDOMProcessingInstruction(static_cast<ProcessingInstruction*>(node));
+            break;
+        case Node::COMMENT_NODE:
+            ret = new GDOMComment(static_cast<Comment*>(node));
+            break;
+        case Node::DOCUMENT_NODE:
+            // we don't want to cache the document itself in the per-document dictionary
+            return toGDOM(static_cast<Document*>(node));
+        case Node::DOCUMENT_TYPE_NODE:
+            ret = new GDOMDocumentType(static_cast<DocumentType*>(node));
+            break;
+        case Node::NOTATION_NODE:
+            ret = new GDOMNotation(static_cast<Notation*>(node));
+            break;
+        case Node::DOCUMENT_FRAGMENT_NODE:
+            ret = new GDOMDocumentFragment(static_cast<DocumentFragment*>(node));
+            break;
+        case Node::ENTITY_REFERENCE_NODE:
+            ret = new GDOMEntityReference(static_cast<EntityReference*>(node));
+            break;
+        default:
+            ret = new GDOMNode(node);
+    }
+
+    doc->ref();
+    return GDOMScriptInterpreter::putDOMNodeForDocument(doc, node, ret);
+}
+ 
+gpointer toGDOM(HTMLCollection* collection)
+{
+    if (!collection)
+        return NULL; /* hmmm.... */
+
+    gpointer gobj = GDOMScriptInterpreter::getDOMObject(collection);
+
+    if (gobj)
+        return gobj;
+
+    GDOMObject *ret;
+    switch (collection->type()) {
+        case HTMLCollection::SelectOptions:
+            ret = new GDOMHTMLOptionsCollection(static_cast<HTMLOptionsCollection*>(collection));
+            break;
+#if 0
+        case HTMLCollection::DocAll:
+            ret = new GDOMHTMLAllCollection(static_cast<HTMLCollection*>(collection));
+            break;
+#endif
+        default:
+            ret = new GDOMHTMLCollection(static_cast<HTMLCollection*>(collection));
+            break;
+    }
+
+    collection->ref();
+    return GDOMScriptInterpreter::putDOMObject(collection, ret);
+}
+
+gpointer toGDOM(Event* event)
+{
+    if (!event)
+        return NULL; /* hmmm.... */
+
+    printf("toGDOM Event type %s\n", event->type().string().utf8().data());
+
+    gpointer gobj = GDOMScriptInterpreter::getDOMObject(event);
+    if (gobj)
+        return gobj;
+
+    GDOMObject *ret;
+    if (event->isUIEvent()) {
+        if (event->isKeyboardEvent())
+            ret = new GDOMKeyboardEvent(static_cast<KeyboardEvent*>(event));
+        else if (event->isTextEvent())
+            ret = new GDOMTextEvent(static_cast<TextEvent*>(event));
+        else if (event->isMouseEvent())
+            ret = new GDOMMouseEvent(static_cast<MouseEvent*>(event));
+        else if (event->isWheelEvent())
+            ret = new GDOMWheelEvent(static_cast<WheelEvent*>(event));
+#if ENABLE(SVG)
+        else if (event->isSVGZoomEvent())
+        {
+            return NULL; /* TODO */
+            //ret = new GDOMSVGZoomEvent(static_cast<SVGZoomEvent*>(event), 0);
+        }
+#endif
+        else
+            ret = new GDOMUIEvent(static_cast<UIEvent*>(event));
+    } else if (event->isMutationEvent())
+        ret = new GDOMMutationEvent(static_cast<MutationEvent*>(event));
+    else if (event->isOverflowEvent())
+        ret = new GDOMOverflowEvent(static_cast<OverflowEvent*>(event));
+    else if (event->isMessageEvent())
+        ret = new GDOMMessageEvent(static_cast<MessageEvent*>(event));
+    else if (event->isProgressEvent()) {
+        if (event->isXMLHttpRequestProgressEvent())
+            ret = new GDOMXMLHttpRequestProgressEvent(static_cast<XMLHttpRequestProgressEvent*>(event));
+        else
+            ret = new GDOMProgressEvent(static_cast<ProgressEvent*>(event));
+    }
+#if ENABLE(DOM_STORAGE)
+    else if (event->isStorageEvent())
+        ret = new GDOMStorageEvent(static_cast<StorageEvent*>(event));
+#endif
+    else if (event->isWebKitAnimationEvent())
+        ret = new GDOMWebKitAnimationEvent(static_cast<WebKitAnimationEvent*>(event));
+    else if (event->isWebKitTransitionEvent())
+        ret = new GDOMWebKitTransitionEvent(static_cast<WebKitTransitionEvent*>(event));
+    else
+        ret = new GDOMEvent(event);
+
+    event->ref();
+    return GDOMScriptInterpreter::putDOMObject(event, ret);
+}
+
+/* TODO XXX hmmm... not so happy about this - should be "newly created" */
+gpointer toGDOM(Text* text)
+{
+    if (!text)
+        return NULL;
+
+    gpointer gobj = GDOMScriptInterpreter::getDOMNodeForDocument(text->document(), text);
+    if (gobj)
+        return gobj;
+
+    GDOMNode *ret = new GDOMText(text);
+    text->document()->ref();
+    return GDOMScriptInterpreter::putDOMNodeForDocument(text->document(), text, ret);
+}
+
+gpointer toGDOM(CSSRule* rule)
+{
+    if (!rule)
+        return NULL; /* XXX hmmm... */
+
+    gpointer gobj = GDOMScriptInterpreter::getDOMObject(rule);
+
+    if (gobj)
+        return gobj;
+
+    GDOMObject *ret;
+    switch (rule->type()) {
+        case CSSRule::STYLE_RULE:
+            ret = new GDOMCSSStyleRule(static_cast<CSSStyleRule*>(rule));
+            break;
+        case CSSRule::MEDIA_RULE:
+            ret = new GDOMCSSMediaRule(static_cast<CSSMediaRule*>(rule));
+            break;
+        case CSSRule::FONT_FACE_RULE:
+            ret = new GDOMCSSFontFaceRule(static_cast<CSSFontFaceRule*>(rule));
+            break;
+        case CSSRule::PAGE_RULE:
+            ret = new GDOMCSSPageRule(static_cast<CSSPageRule*>(rule));
+            break;
+        case CSSRule::IMPORT_RULE:
+            ret = new GDOMCSSImportRule(static_cast<CSSImportRule*>(rule));
+            break;
+        case CSSRule::CHARSET_RULE:
+            ret = new GDOMCSSCharsetRule(static_cast<CSSCharsetRule*>(rule));
+            break;
+        case CSSRule::VARIABLES_RULE:
+            ret = new GDOMCSSVariablesRule(static_cast<CSSVariablesRule*>(rule));
+            break;
+        default:
+            ret = new GDOMCSSRule(rule);
+            break;
+    }
+
+    rule->ref();
+    GDOMScriptInterpreter::putDOMObject(rule, ret);
+    return ret;
+}
+
+/* TODO: should be toGDOMNewlyCreated */
+gpointer toGDOM(Element* element)
+{
+    if (!element)
+        return NULL;
+
+    // shouldn't be one? ASSERT(!ScriptInterpreter::getDOMNodeForDocument(element->document(), element));
+    gpointer gobj = GDOMScriptInterpreter::getDOMNodeForDocument(element->document(), element);
+    if (gobj)
+        return gobj; // huh? err...
+
+    GDOMNode *ret;
+    Document* doc = element->document();
+
+    if (element->isHTMLElement())
+        ret = createGDOMHTMLWrapper(static_cast<HTMLElement*>(element));
+#if ENABLE(SVG)
+    else if (element->isSVGElement())
+    {
+        return NULL; /* TODO */
+        //ret = createGDOMSVGWrapper(static_cast<SVGElement*>(element));
+    }
+#endif
+    else
+        ret = new GDOMElement(element);
+
+    doc->ref();
+    return GDOMScriptInterpreter::putDOMNodeForDocument(doc, element, ret);
+}
+
+gpointer toGDOM(StyleSheet* styleSheet)
+{
+    if (!styleSheet)
+        return NULL; /* err... */
+
+    gpointer gobj = GDOMScriptInterpreter::getDOMObject(styleSheet);
+    if (gobj)
+        return gobj;
+
+    GDOMObject *ret;
+    if (styleSheet->isCSSStyleSheet())
+        ret = new GDOMCSSStyleSheet(static_cast<CSSStyleSheet*>(styleSheet));
+    else
+        ret = new GDOMStyleSheet(styleSheet);
+
+    styleSheet->ref();
+    return GDOMScriptInterpreter::putDOMObject(styleSheet, ret);
+}
+
+/* derived sources auto-generated */
+gpointer toGDOM(XMLHttpRequestUpload* obj);
+
+gpointer toGDOM(EventTarget* target)
+{
+    if (!target)
+        return NULL;
+    
+#if 0
+#if ENABLE(SVG)
+    // SVGElementInstance supports both toSVGElementInstance and toNode since so much mouse handling code depends on toNode returning a valid node.
+    SVGElementInstance* instance = target->toSVGElementInstance();
+    if (instance)
+        return toGDOM(exec, instance);
+#endif
+#endif
+
+    Node* node = target->toNode();
+    if (node)
+        return toGDOM(node);
+    
+    if (XMLHttpRequest* xhr = target->toXMLHttpRequest())
+        // XMLHttpRequest is always created via GDOM, so we don't need to use cacheDOMObject() here.
+        return GDOMScriptInterpreter::getDOMObject(xhr);
+
+    if (XMLHttpRequestUpload* upload = target->toXMLHttpRequestUpload())
+        return toGDOM(upload);
+    
+#if ENABLE(OFFLINE_WEB_APPLICATIONS)
+    if (DOMApplicationCache* cache = target->toDOMApplicationCache())
+        // DOMApplicationCache is always created via GDOM, so we don't need to use cacheDOMObject() here.
+        return GDOMScriptInterpreter::getDOMObject(cache);
+#endif
+
+    // There are two kinds of EventTargets: EventTargetNode and XMLHttpRequest.
+    // If SVG support is enabled, there is also SVGElementInstance.
+    ASSERT_NOT_REACHED();
+    return NULL;
+}   
+
+gpointer toGDOM(EventTargetNode* target)
+{
+    if (!target)
+        return NULL;
+    
+    Node* node = target->toNode();
+    if (node)
+        return toGDOM(node);
+    
+    return toGDOM(static_cast<EventTarget*>(target));
+}
+
+} // namespace WebCore
+
Index: WebCore/bindings/gdom/GdomDOMObject.h
===================================================================
--- WebCore/bindings/gdom/GdomDOMObject.h	(revision 0)
+++ WebCore/bindings/gdom/GdomDOMObject.h	(revision 0)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+#ifndef __GdomDOMObject_H__
+#define __GdomDOMObject_H__
+#include "glib-object.h"
+#include <webkit/webkitdefines.h>
+
+G_BEGIN_DECLS
+
+typedef struct _GdomDOMObject GdomDOMObject;
+typedef struct _GdomDOMObjectClass GdomDOMObjectClass;
+
+#define GDOM_TYPE_DOM_OBJECT            (gdom_dom_object_get_type())
+#define GDOM_DOM_OBJECT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_DOM_OBJECT, GdomDOMObject))
+#define GDOM_DOM_OBJECT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_DOM_OBJECT, GdomDOMObjectClass))
+#define GDOM_IS_DOM_OBJECT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_DOM_OBJECT))
+#define GDOM_IS_DOM_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_DOM_OBJECT))
+#define GDOM_DOM_OBJECT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_DOM_OBJECT, GdomDOMObjectClass))
+
+typedef struct _GdomDOMObjectPrivate GdomDOMObjectPrivate;
+
+struct _GdomDOMObject {
+    GObject parent_instance;
+
+    GdomDOMObjectPrivate *priv;
+};
+
+struct _GdomDOMObjectClass {
+    GObjectClass parent_class;
+};
+
+WEBKIT_API GType
+gdom_dom_object_get_type (void);
+
+WEBKIT_API void
+gdom_dom_object_init_dom_object (GdomDOMObject *thiz);
+
+G_END_DECLS
+
+#endif /* __GdomDOMObject_H__ */
+
Index: WebCore/bindings/gdom/GDOMObject.h
===================================================================
--- WebCore/bindings/gdom/GDOMObject.h	(revision 0)
+++ WebCore/bindings/gdom/GDOMObject.h	(revision 0)
@@ -0,0 +1,14 @@
+#ifndef __DOMObject_h__
+#define __DOMObject_h__
+
+// namespace WebCore {
+
+class GDOMObject {
+public:
+    virtual ~GDOMObject() {}
+    virtual int get_gobj_type() = 0;
+};
+
+// } // namespace WebCore
+
+#endif
Index: WebCore/bindings/gdom/GDOMBinding.h
===================================================================
--- WebCore/bindings/gdom/GDOMBinding.h	(revision 0)
+++ WebCore/bindings/gdom/GDOMBinding.h	(revision 0)
@@ -0,0 +1,91 @@
+/*
+ *  Copyright (C) 1999-2001 Harri Porten (porten@kde.org)
+ *  Copyright (C) 2003, 2004, 2005, 2006, 2008 Apple Inc. All rights reserved.
+ *  Copyright (C) 2007 Samuel Weinig <sam@webkit.org>
+ *  Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ *
+ *  This library is free software; you can redistribute it and/or
+ *  modify it under the terms of the GNU Lesser General Public
+ *  License as published by the Free Software Foundation; either
+ *  version 2 of the License, or (at your option) any later version.
+ *
+ *  This library is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ *  Lesser General Public License for more details.
+ *
+ *  You should have received a copy of the GNU Lesser General Public
+ *  License along with this library; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef GdomDOMBinding_h
+#define GdomDOMBinding_h
+
+#include <kjs/interpreter.h>
+#include <kjs/lookup.h>
+#include <wtf/Noncopyable.h>
+
+#include "GdomNode.h"
+#include "GDOMObject.h"
+#include "PrivateIntGdomNode.h"
+
+namespace WebCore {
+
+    class AtomicString;
+    class Document;
+    class Event;
+    class Frame;
+    class KURL;
+    class Node;
+    class String;
+
+#if ENABLE(SVG)
+    class SVGElement;
+#endif
+
+    class GDOMScriptInterpreter {
+    public:
+        static void* getDOMObject(void* objectHandle);
+        static void* putDOMObject(void* objectHandle, GDOMObject*);
+        static void forgetDOMObject(void* objectHandle);
+
+        static void* getDOMNodeForDocument(Document*, Node*);
+        static void* putDOMNodeForDocument(Document*, Node*, GDOMNode* nodeWrapper);
+        static void forgetDOMNodeForDocument(Document*, Node*);
+        static void forgetAllDOMNodesForDocument(Document*);
+		#if 0
+        static void updateDOMNodeDocument(Node*, Document* oldDoc, Document* newDoc);
+        static void markDOMNodesForDocument(Document*);
+		#endif
+    };
+
+    // Retrieve from cache, or create, a Gdom wrapper for a DOM object.
+    template<class DOMObj, class GdomDOMObj> inline void* cacheDOMObject(DOMObj* domObj)
+    {
+        if (!domObj)
+            return NULL; /* XXX hmmm... */
+        if (void* ret = GDOMScriptInterpreter::getDOMObject(domObj))
+            return ret;
+        GDOMObject* ret = new GdomDOMObj(domObj);
+		domObj->ref();
+        return GDOMScriptInterpreter::putDOMObject(domObj, ret);
+    }
+
+#if ENABLE(SVG)
+    // Retrieve from cache, or create, a Gdom wrapper for an SVG DOM object.
+    template<class DOMObj, class GdomDOMObj> inline void* cacheSVGDOMObject(DOMObj* domObj, SVGElement* context)
+    {
+        if (!domObj)
+            return NULL; /* XXX hmmm... */
+        if (void* ret = GDOMScriptInterpreter::getDOMObject(domObj))
+            return ret;
+        GDOMObject* ret = new GdomDOMObj(domObj, context);
+		domObj->ref();
+        return GDOMScriptInterpreter::putDOMObject(domObj, ret);
+    }
+#endif
+
+} // namespace WebCore
+
+#endif // GdomDOMBinding_h
Index: WebCore/bindings/gdom/PrivateIntGdomDOMObject.h
===================================================================
--- WebCore/bindings/gdom/PrivateIntGdomDOMObject.h	(revision 0)
+++ WebCore/bindings/gdom/PrivateIntGdomDOMObject.h	(revision 0)
@@ -0,0 +1,8 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+#include "GDOMObject.h"
+
